set version "08.03.01"

## *** Enhanced Noise Transfer script 8.03.01 ***
## *** updated 2021.03.01
## Changes:
##	- Added better handling of CAT output file header [ENT-46]
##  - removed need to set up Paragon-X when re-processing [ENT-50]
##
## *** Enhanced Noise Transfer script 8.03.00 ***
## *** updated 2021.02.15
## Changes:
##	- Added support for parameter  1ppsImpedance  to allow measurement port Impedance to be set to R50 or HIGH_IMPEDANCE
##  - fixed bug whereby SyncE-1PPS or PTP-1PPS modes would fail if no PTP traffic was seen on Port 2. No PTP traffic is required on Port2 in these modes
##
## *** Enhanced Noise Transfer script 8.02.00 ***
## *** updated 2020.05.29
## Changes:
##	- Finding and installing rbc is difficult with ActiveState Tcl 8.6 so changes made to support 8.5
## *** Enhanced Noise Transfer script 8.01.00 ***
## *** updated 2020.03.10
## Changes:
##	- Improved handling of Link Status checking - when one or more links is missing
##  - Removed redundant check for Port 2 Link Status check when performing SyncE-1PPS or PTP-1PPS test (T-TSC testing)
## *** Enhanced Noise Transfer script 8.00.00 ***
## *** updated 2020.01.07
## Changes:
##	- Added support for uncoupled interfaces
##  - using --PortConfig1/2  parameter block
#---
# *** Enhanced Noise Transfer script 7.01.00 ***
# *** updated 2018.11.19
# Changes:
#	- Updated with changes to limits as specified in ITU contribution SG15-C0768
#	- Note: For the SYncE point at 0.06156, the change fixes a defect where the maximum limit was too low.
#	- Improved handling of instrument reset (incorporating changes that already existing in the paragon.tcl wrapper)
#---
# *** Enhanced Noise Transfer script 6.01.01 ***
# *** updated 2018.08.24
# Changes:
#	- Fixed bug reported in CSAM-108: Baseline measurement tries to get 1pps result when no 1pps measurement has been made
#---
# *** Enhanced Noise Transfer script 6.01.00 ***
# *** updated 2018.07.27
# Changes:
#	- At lower frequencies, the SyncE stimulus amplitude has been increased.
#		The amplitudes are lower than must be tolerated by the DUT and allows for better SNR
#		This change also results in a tcl file being created in the results folder to record the stimulus used
#		This tcl file is then used when re-processing data
#	- Fixed bug where limit calculation for graphing was wrong when Yaxis was set to GAIN
#	- Fixed a bug where Filter=NONE did not work (terminated script) when measuring 1pps
#	- Added some more checking for error conditions (such as links being down)
#	- Added 120 seconds of PTP/1pps measurement before applying the stimulus.
#		This provides more information about the DUT performance for later data analysis
#	- Graphing now defaults to GraphngYAxis=GAIN (rather than AMPLITUDE)
#		This is as a result of the change to the SyncE stimulus amplitudes - the gain plot is less confusing
#	- Added capture during settling period. This can be used for later analysis of an issues that might arise during testing
#	- Hard-coded the main window width. The auto-detection of the width appears to report incorrectly and so the window ended up being too narrow.
#		Note: This means that should the UI layout change, the width will have to be manually altered
#	- Now using "winop raise" rather than "raise". This may or may not resolve the snapshot issues when there are over-lapping windows
#---
# *** Enhanced Noise Transfer script 6.00.00 ***
# *** updated 2018.06.21
# Changes:
#	- Major re-write to support potential future enhancements. This includes re-structuring to support P100G reprocessing
#   - Limits can now be switched off (for use when customers want to apply their own limits)
#	- A tcl file is now generated in the Results folder. This contains the stimulus list used for the test.
#		This is not currently used but will be needed if there are changes to noise amplitudes in the future
#	- The SyncE limits are now calculated using N=25
#		(this is required because the limits did not take account of the noise added to PTP when applying SyncE wander)
#	- Graphing now disabled by default (customers having problems installing Tcl libraries)
#	- Improved checking for set-up problems e.g. no link, no packets
#	- Added support for plotting gain (GraphingYAxis=GAIN) not just amplitude (GraphingYAxis=AMPLITUDE)
#---
# *** Enhanced Noise Transfer script 5.01.03 ***
# *** updated 2018.05.09
# Changes:
#	- Checks that required packages are installed and if not, prints error message and exits
#	- SyncE measurements are switched on by default in the Defaults.tcl configuration file
#   - Autonegotiate now allowed except for 10GBE interfaces
#   - Capture duration extended to include RecoveryTime
#   - Trap added to allow script to run if instrument does not have option 205 enabled (Wander Measurement)
#---
#---
# *** Enhanced Noise Transfer script 5.01.02 ***
# *** updated 2018.02.02
# Changes:
#	- CSIND-56: ESMC generation now started before MSE and device settling time
#	- Fix to resolve issue where error is generated when UI window is obscured during screengrab
#	- Minor changes as a result of Getting Started Guide review
#---
# *** Enhanced Noise Transfer script 5.01.01 ***
# *** updated 2018.01.21
# Changes:
#	New Settings / Capabilties
#	- Added setting to allow sub-set of points to be executed
#---
# *** Enhanced Noise Transfer script 5.01.00 ***
# *** updated 2018.01.21
# Changes:
#	New Settings / Capabilties
#	- Added setting to configure for 2-step DUT
#	User Settings
#   - Re-worked mechanism for making script settings
#	- Command line options still work but settings can also be made using a specified config file
#	- This has been added so as to avoid forcing users to type long command lines
#	Defaults
#	- The default settings now use a similar mechanism - they are stored in a separate tcl file
#	- This allows users to change the Defaults.tcl file without having to edit the main script
#	- This has been changed to allow users to define their defaults and then execute the script
#	  with no arguments
#---
# *** Enhanced Noise Transfer script 5.00.00 ***
# *** updated 2018.01.20
# Changes:
#   - LSQ now being used for 1pps
#	- PTP and 1pps measurements now combined
#		Get both PTP and 1pps results from one test run using Type PTP-BOTH and SyncE-BOTH
#		Default changed to PTP-BOTH
#	- Updated Graphing for the above
#---
# *** Enhanced Noise Transfer script 4.00.00 ***
# *** updated 2017.11.17
# Changes:
#   - Increased default recovery time from 20s to 50s
#   - Increased high freq capture durations from 200s to 250s
#   - Measurement now being performed on T4 so as to guarantee sample rate
#   - Modified limts to use N=10 (rather than N=5)
#   - Added GUI port as a parameter
#   - Updated graphing support
#---
# *** Enhanced Noise Transfer script 3.02.00 ***
# *** updated 2017.11.08
# Changes:
#   - Added basic graphing support
#	- Added support for recovery time for 1pps measurements
#---
# *** Enhanced Noise Transfer script 3.01.00 ***
# *** updated 2017.11.02
# Changes:
#   Issue when packet rate is not 16 pkts/s
#	- Changed results structure to include time series from capture
#   - The time series is then used directly in the filter algorithm
#   - This is required to avoid issues when the input sample rate is not 16 pkt/s
#   Need for rest package
#   - Moved the "require" statement so that is is only executed when GuiIP is not localhost
#---
# *** Enhanced Noise Transfer script 3.0.07 ***
# *** updated 2017.10.27
# Changes:
#   -  Correction applied to Common Function - GetMin /GetMax to load correct values
#
# *** Enhanced Noise Transfer script 3.0.06 ***
# *** updated 2017.10.13
# Changes:
#	- Moved Master Slave Emulation Start/Stop out of the main loop
#	- Moved wait on deviceSettlingTime out of main loop  
#	- Only need to Start/Stop Master/Slave at start and end of complete test
#	- removed test for AutoNegotiate being TRUE, was not setting default FALSE state, Now always set based on parameter setting
#
# *** Enhanced Noise Transfer script 3.00.05 ***
# *** updated 2017.08.31
# Changes:
#	- Added timeout control on packetCapture function to stop script hanging if capture status not reaching stopped
#
# *** Enhanced Noise Transfer script 3.00.04 ***
# *** updated 2017.08.21
# Changes:
#	- Fixed bug where 1pps capture was not enabled
#
# *** Enhanced Noise Transfer script 3.00.03 ***
# *** updated 2017.08.21
# Changes:
#	- Change to support generation of a log file (as opposed to output going only to stdout)
#	- Fixed bug where SyncE-PTP results could not be retrieved from a remote host
#
# *** Enhanced Noise Transfer script 3.00.02 ***
# *** updated 2017.08.18
# Changes:
#	- Fix to remove offset from data prior to filtering using LSQ
#	- Failure to save capture file is now not fatal; execution will continue
#
# *** updated 2017.08.14
# Changes:
#	- Minor fix for paths used when P-X GUI is running remotely
#
# *** Enhanced Noise Transfer script 3.00.00 ***
# *** updated 2017.08.11
# Changes:
#	- Added support for command line arguments
#   - Added support for least squares filter as specified in Amendment 1 to G.8273.2
#   - Added support for demo mode processing of previous captures
#   - Added support for script generation of test data for filter testing (Calnex only)
#   - Re-factored for addition of new filter
#	- Added filter selector to command line options
#	- Added limits with pass/fail
#	- Added support for filterType = NONE
#	- Added storage of capture files in script directory
#			(improves later debug capability and allows post-processing)
#	- Added a window before processing the data (to allow the DUT to recover after seeing the noise)
#	- Added support for a remote PC hosting the P-X GUI
#   - Updated the documentation
#
# *** updated 2016.06.28
# *** 15th Mar 2017 Version 2.00.00
# Changes:
#   - Updated to add SyncE to PTP
#   - Change to the frequency points being used
#

# ##############################################################################
# Settings
# ------------------------------------------------------------------------------
# The script allows a number of settings to be made. These are a mix of instrument
# and script configuration
#
# There are three possible sources for settings:
# - Defaults: as defined in Defaults.tcl
# - Command Line: set using key,value pairs as arguments to the script
# - Config File: A file can be specified on the command line which contains user settings
#
# The precedence for settings is defined by the order of processing:
# - All settings are initially taken from the defaults
# - If a config file is specified, then the settings in that file are processed
#		These settings over-ride the defaults
# - Once any config file is processed, command line arguments are processed
#		Command line arguments over-ride both the config file and defaults
# The exception to the above is that the Config File setting is taken ONLY from the command line
#
# Settings are defined as a series of <key, value> pairs
# The key is the name of the setting; the value is used to initialise that setting
# In the Defaults.tcl and any user-defined config file, the key,value pairs are defined
# in a tcl structure known as a dictionary. See the Defaults.tcl file for an example
#
# From the command line the key,value pairs are entered as a series of arguments where
# the key name is specified and this is followed by the value. 
# Example: tclsh G.8373.2.tcl Type PTP-PTP Class 50 DeviceSettlingTime 50
#
# Default settings will be used for parameters that are not specified.
# Note that the Defaults.tcl file must define a default value for all possible settings.
#
# Examples:
#	tclsh G.8273.2.tcl 
#		Executes the script using the defaults defined in Default.tcl
#   tclsh G.8273.2.tcl ConfigFile config.tcl
# 		Executes the script using the defaults but settings are over-ridden by those in config.tcl
#	tclsh G.8273.2.tcl ConfigFile config.tcl Type SyncE-PTP
#		Executes the script using the defaults with settings over-ridden by those in config.tcl and
#       with Type set to SyncE-PTP on the command line 
#
# The keys and possible values for all valid settings are listed below.
# For numeric values, the type is shown; check the remote control manual for range information.
# The default value for each setting is defined in the Defaults.tcl file.
#
# InstrIp		IP address of the P-X											<IP Addr>
# GuiIp			IP address of the PC running the P-X GUI						<IP Addr> or <localhost>
#               If GuiIp is not "localhost", then it is assumed that the PC is remote to the script host.
#               In this case, results will be retrieved using http requests
# GuiPort		The port to use to connect to the P-X GUI						<integer>
# Type			Noise transfer stimulus and measurement							PTP-BOTH, PTP-PTP, PTP-1PPS, SyncE-BOTH, SyncE-PTP, SyncE-1PPS
# SyncEPoints	List specifying which points to use for SyncE stimulus			ALL or list of points e.g. "0 4 5 11". Points are indexed from zero
# PtpPoints		List specifying which points to use for PTP stimulus			ALL or list of points e.g. "1 5 7 8 9". Points are indexed from zero
# CableDelay 	Delay (in ns) due to cable from BC master to P-X slave 			<integer>
# LineRate 		Line rate 														1GBE, 100BASET, 10GBE
# Interface 	Interface 														ELECTRICAL, OPTICAL, XFP, SFPPLUS
# Reference		Source of frequency reference									EXT_10M, EXT_R75_E1, EXT_R100_T1, EXT_R100_E1, EXT_K64, INT
# TwoStep		Whether the device under test is a two-step clock				TRUE, FALSE
# SettlingTime 	Time (in secs) to allow the device to settle after MSE starts	<integer>
# RecoveryTime 	Time (in secs) to allow the device to recover after noise starts	<integer>
# 1ppsThreshold Voltage threshold for 1pps measurement input 					<float>
# 1ppsImpedance 1pps Aux Measurement Port Impedance                             R50, HIGH_IMPEDANCE
# AutoNegotiate Enable or disable auto negotiation 								TRUE, FALSE
# SyncE			Enable or disable SyncE measurement during test					TRUE, FALSE
# RemoteCaptureFolder	The folder in which to store capture files on the 		<path/filename>
#						remote Windows PC.
# RemoteProfileFolder	The folder from which prfoiles will be loaded on the	<path/filename>
#						remote Windows PC
# Debug         Enable or disable additional debug information					TRUE, FALSE
# ReProcess		Allows the script to run with P-X in demo mode and to			TRUE, FALSE
#                   re-process previously captured data
#               Uses pre-existing files in specified directory.
# Filter		Defines the filter type to use. For Calnex use only				IIR, LSQ, NONE
# SimulatedData Generates test data to run through the filter.					TRUE, FALSE
#                   For Calnex use only
# Graphing		Enable graphical UI for results									TRUE, FALSE
# GraphingYAxis	Plot results as either Gain(dB) or Amplitude(ns)				GAIN, AMPLITUDE
# ConfigFile	File containing user-defined settings. The file must exist		<filename>
#					in the same folder as this script
#
# Note: 
#	Error checking on the input parameters is limited.
#	In particular, couplings between parameters are not checked e.g. some line rates are not compatible with some interfaces
#   Incompatible parameter settings may either result in incorrect performance or errors in the main body of the script
#   It is the caller's responsibility to ensure that the parameter names and values are correct.
#	Keys are case sensitive as are those values passed directly to P-X
#   SimulatedResults will not work with Filter=NONE
#
# TODO: Make error checking of arguments more robust
#------------------------------------------------------------------------------
# Design notes:
# - The argument list is passed into this script as a (possibly) long list of arguments.
#	This list is then treated as a dictionary. A dictionary is a list of <key,value> pairs.
#	Dictionary functions can then be used to get the value for any given key
# - The "defaults" list is used as a dictionary. The keys in the list are those used to
#	look for command line arguments
# - A new dictionary is then created that contains the combination of defaults,
#	config file and command line settings
#------------------------------------------------------------------------------

# There are some differences between tcl 8.5 and 8.6
# Record whether the version is 8.5 or older
set tcl_version [info tclversion]
if {$tcl_version < 8.6} {
	set tcl_pre86 True
	puts "Tcl version: $tcl_version ($tcl_pre86)"
} else {
	set tcl_pre86 False
	puts "Tcl version: $tcl_version ($tcl_pre86)"
}

# This is necessary for tcl 8.5 but not for 8.6
if {$tcl_pre86} {
	package require TclOO
	namespace import oo::*
	package require try
}

# This script can be used to re-process P100G captures. 
# If the variable below is set to True, then P100G re-processing is enabled
global P100GNoiseTransferFile
set P100GNoiseTransferFile False
#set P100GNoiseTransferFile TRUE

source "./measurements.tcl"
source "./Initialization.tcl"
source "./Time Noise Transfer.tcl"
source "./Common functions.tcl"


# #############################################################################
# Check a settings file for different errors
# Returns to the caller if everything is OK; otherwise will terminate the script
# -----------------------------------------------------------------------------
proc checkSettingsFile {filename dictionaryName validKeys} {
	# Make sure the file exists. If not, just give up
	if {[file exists $filename] == 0} {
		puts "File ($filename) not found. Aborting."
		exit
	}
	# File exists so read it. If there is an error, provide a useful error messages
	if {[catch {source $filename} err]} {
		puts "Tcl syntax error in file ($filename): $err"
		exit
	}
	# File has been parsed OK. Now check that it contains the expected dictionary
	if {[info exists dictionaryName] == 0} {
		puts "File ($filename) does not contain a dictionary named \"$dictionaryName\""
		exit
	}
	# Check it contains only valid keys
	# The syntax here is weird [set $dictionaryName] is essentially doing a dereference to get the actual dictionary
	set keys [dict keys [set $dictionaryName]]
	# Check for invalid keys
	foreach key $keys {
		if {$key ni $validKeys} {
			puts "Unrecognised key ($key) in file ($filename)"
			exit
		}
	}
}
# ------------------------------------------------------------------------------
# Dictionary containing keys and dummy values. This contains the full list of 
# keys (setting names) that are valid.
# This is ued for checking user defined config files as well as settings made on
# on the command line.
set validKeyDict {
	InstrIp	 			""
	GuiIp				""
	GuiPort				""
	Type 				""
	CableDelay 			""
	LineRate 			""
    LineRatePort1       ""
    LineRatePort2       ""
	Interface 			""
    InterfacePort1      ""
    InterfacePort2      ""
	Reference 			""
	TwoStep             ""
	SettlingTime 		""
	RecoveryTime 		""
	1ppsThreshold 		""
    1ppsImpedance       ""
	LimitsEnabled		""
	AutoNegotiate 		""
    AutoNegotiatePort1  ""
    AutoNegotiatePort2  ""
	SyncE 				""
	RemoteCaptureFolder	""
	RemoteProfileFolder	""
	Debug 				""
	ReProcess			""
	Filter				""
	SimulatedData 		""
	Graphing      		""
	GraphingYAxis      	""
	ConfigFile			""
	SyncEPoints			""
	PtpPoints			""
    MasterMcastAddress  ""
    SlaveMcastAddress   ""
    Port1Config         ""
    Port2Config         ""
}
# ------------------------------------------------------------------------------

# These keys are not relevant when re-procesing data and so are marked as NA on the UI
set reprocessIgnore {CableDelay LineRate Interface Reference SettlingTime 1ppsThreshold 1ppsImpedance AutoNegotiate SyncE}
# These settings are not shown on the UI
set reprocessOmit {RemoteCaptureFolder RemoteProfileFolder Graphing GuiPort Debug}

# The defaults settings are contained in a separate tcl file. This allows the default settings to
# be changed without editting the main G.8273.2.tcl file and allows the script to be run with no arguments
# Make sure the file doesn't have any tcl errors
checkSettingsFile "Defaults.tcl" "defaults" $validKeyDict
# Defaults.tcl is OK - load the file and use the settings as the base parameters
set defaults "No defaults defined"
source "Defaults.tcl"
set parameters $defaults

# -------------- Process the settings ------------------------------------------
set oddNumberOfParams [expr {($argc % 2)}]
if { $argc == 0 } {
	puts "Using default parameters"
} elseif { $oddNumberOfParams != 0} {
	puts "Argument list must contain <key,value> pairs. There must be an even number of arguments"
	exit
} else {
    #puts "$argc arguments: $argv"
	set inputKeys [dict keys $argv]
	set validKeys [dict keys $validKeyDict]

	# -------- Config File ----------
	# If a config file has been specified, then process it
	if {"ConfigFile" in $inputKeys} {
		set userDefinedConfig "No config defined"
		set cfile [dict get $argv "ConfigFile"]
		# Check that the file is OK
		checkSettingsFile $cfile "userDefinedConfig" $validKeyDict
		source $cfile

		# For each key in the valid list, look for the same key in the user defined settings
		# If it exists, then set the value in the parameters list
		foreach k $validKeys {
			if [dict exists $userDefinedConfig $k] {
				set value [dict get $userDefinedConfig $k]
				set parameters [dict replace $parameters $k $value]
			}
		}		
	}

	# ---------- Command Line Arguments ----------
	# Check for invalid keys in the input arguments
	foreach inputKey $inputKeys {
		if {$inputKey ni $validKeys} {
			puts "Unrecognised key: $inputKey"
			exit
		}
	}
	# For each key in the defaults list, look for the same key in the input arguments
	# If it exists, then set the value in the parameters list
    # DJWAT AE-7
    #
    # Exception to this is the Port1Config/Port2Config parameters which are complex and need additional
    # parsing. Also if these are used need to ignore the coupled set (LineRate/Interface/AutoNegotiate)
    
    # DJWAT AE-7
    
    set portConfigCount 0
    
	foreach k $validKeys {
		if [dict exists $argv $k] {
            
            set value [dict get $argv $k]
    #      DJWAT AE-7       
	#		set parameters [dict replace $parameters $k $value]
            switch $k {
                Port1Config {
                   
                    # parse the content of Port1Config
                    # set the individual Port fields
                    # increment portConfigCount
                    set lRate [ lindex $value 0]
                    if { $lRate == "1GBE" || $lRate == "10GBE" || $lRate == "100BASET"} {
                        set parameters [dict replace $parameters LineRatePort1 $lRate]
                    } else {       
                        log "ERROR:  Port1Config - Interface ($lRate) should be one 1GBE,10GBE,100BASET"
                        exit
                    }
                    
                    set iFace [ lindex $value 1]
                    if { $iFace == "ELECTRICAL" || $iFace == "OPTICAL" || $iFace == "XFP" || $iFace == "SFPPLUS"} {
                        set parameters [dict replace $parameters InterfacePort1 $iFace]
                    } else {       
                        log "ERROR:  Port1Config - Interface ($iFace) should be one ELECTRICAL, OPTICAL, SFPPLUS, XFP"
                        exit
                    }
                    
                    
                    set autoVal [ lindex $value 2]
                    if { $autoVal == "FALSE" || $autoVal == "TRUE" } {
                        set parameters [dict replace $parameters AutoNegotiatePort1 $autoVal]
                    } else {       
                        log "ERROR:  Port1Config - AutoNegotiate Setting ($autoVal) should be one TRUE,FALSE"
                        exit
                    }
                    #puts "PortConfig1 lRate $lRate iFace $iFace autoVal $autoVal"
 
                    incr portConfigCount 1
                }
                Port2Config {

                    set lRate [ lindex $value 0]
                    if { $lRate == "1GBE" || $lRate == "10GBE" || $lRate == "100BASET"} {
                        set parameters [dict replace $parameters LineRatePort2 $lRate]
                    } else {       
                        log "ERROR:  Port2Config - Interface ($lRate) should be one 1GBE,10GBE,100BASET"
                        exit
                    }
                    
                    set iFace [ lindex $value 1]
                    if { $iFace == "ELECTRICAL" || $iFace == "OPTICAL" || $iFace == "XFP" || $iFace == "SFPPLUS"} {
                        set parameters [dict replace $parameters InterfacePort2 $iFace]
                    } else {       
                        log "ERROR:  Port2Config - Interface ($iFace) should be one ELECTRICAL, OPTICAL, SFPPLUS, XFP"
                        exit
                    }
                    
                    
                    set autoVal [ lindex $value 2]
                    if { $autoVal == "FALSE" || $autoVal == "TRUE" } {
                        set parameters [dict replace $parameters AutoNegotiatePort2 $autoVal]
                    } else {       
                        log "ERROR:  Port2Config - AutoNegotiate Setting ($autoVal) should be one TRUE,FALSE"
                        exit
                    }
                    #puts "PortConfig2 lRate $lRate iFace $iFace autoVal $autoVal"
                    incr portConfigCount 1
                }
                default {
                    #puts "************************"
                    #puts "overwrite param $k"
                    set parameters [dict replace $parameters $k $value]
                }
            }
            
		}
	}
    
    
    # DJWAT AE-7
    # check that Port1Config/Port2Config parameters have both been set or neither
    
    if { $portConfigCount == 0} {
        # no PortConfig parameters so set individuals from coupled values
        set parameters [ dict replace $parameters InterfacePort1 [ dict get $parameters Interface]]
        set parameters [ dict replace $parameters InterfacePort2 [ dict get $parameters Interface]]
        set parameters [ dict replace $parameters LineRatePort1 [ dict get $parameters LineRate]]
        set parameters [ dict replace $parameters LineRatePort2 [ dict get $parameters LineRate]]
        set parameters [ dict replace $parameters AutoNegotiatePort1 [ dict get $parameters AutoNegotiate]]
        set parameters [ dict replace $parameters AutoNegotiatePort2 [ dict get $parameters AutoNegotiate]]
    } elseif { $portConfigCount == 1} {
        log "ERROR:  Both Port1Config and Port2Config parameters must be defined at the same time"
        exit
    }
    
}
#------------------------------------------------------------------------------

# ##############################################################################
# Globals
# ------------------------------------------------------------------------------
# Debugging and test mode flags should NOT be changed from defaults when testing devices
global demoMode
global debugTrace
global simulatedData
global filterType
# Remote indicator and hostname (GUI IP) are global
# When remoteHost is true, http requests will be used to retrieve data from the remote PC
global remoteHost
global guiHostname

set debugTrace [dict get $parameters "Debug"]
set demoMode [dict get $parameters "ReProcess"]
set simulatedData [dict get $parameters "SimulatedData"]
set filterType [dict get $parameters "Filter"]

set remoteHost FALSE
# ------------------------------------------------------------------------------

# ##############################################################################
# Test type
# ------------------------------------------------------------------------------
# Type of noise transfer test:
#
#   PTP-BOTH     -  input stimulus PTP impairment  output measure: PTP and 1pps
#   PTP-PTP      -  input stimulus PTP impairment  output measure: PTP
#   PTP-1PPS     -  input stimulus PTP impairment  output measure: 1PPS
#
#   SyncE-BOTH   -  input stimulus SYNCE Wander stimulus  output measure: PTP and 1pps
#   SyncE-PTP    -  input stimulus SYNCE Wander stimulus  output measure: PTP
#   SyncE-1PPS   -  input stimulus SYNCE Wander stimulus  output measure: 1PPS
#
set noiseTransferType [dict get $parameters "Type"]

# ##############################################################################
# Initialise logging
# ------------------------------------------------------------------------------
# This is done as soon as possible so that output can be logged for most of the script
initialiseLogging $demoMode $noiseTransferType

# ##############################################################################
# Masurement/Instrument Configuration
# ------------------------------------------------------------------------------
# Always enable 1pps
# 
set onePps "AccuracyCaptEnable"
set syncE [dict get $parameters "SyncE"]
# pdh wander: T1WanderCaptEnable, E1WanderCaptEnable, M2WanderCaptEnable, None
set pdhWander "None"
# sync to an external 1pps
set syncToExternal1pps FALSE
# Voltage level of 1pps Measurement signal 
set 1ppsLevel [dict get $parameters "1ppsThreshold"]

# 1pps Impedance settting
set 1ppsImpedance [ dict get $parameters "1ppsImpedance"]

# DUT to Paragon-x Cable Delay
set cableDelay [dict get $parameters "CableDelay"]
# line rate: 1GBE, 100BASET, 10GBE

#DJWAT AE-7
#set lineRate [dict get $parameters "LineRate"]

set lineRatePort1 [ dict get $parameters "LineRatePort1"]
set lineRatePort2 [ dict get $parameters "LineRatePort2"]

# interface 
#
# ELECTRICAL  - for LineRate 100BASET or 1GBE
# OPTICAL     - for LineRate 1GBE   SFP  
# XFP         - For LineRate 10GBE  SFP+    /* Sets lineRate to be 10GBE */
# SFPPLUS     - for LineRate 10GBE  XFP     /* Sets lineRate to be 10GBE */
#
#DJWAT AE-7
#set interface [dict get $parameters "Interface"]
set interfacePort1 [dict get $parameters "InterfacePort1"]
set interfacePort2 [dict get $parameters "InterfacePort2"]

# clock source: EXT_10M, EXT_R75_E1, EXT_R100_T1, EXT_R100_E1, EXT_K64, INT
set referenceFrequency [dict get $parameters "Reference"]
# change Ethernet to auto negotiate

#DJWAT AE-7
#set autoNegotiate [dict get $parameters "AutoNegotiate"]
set autoNegotiatePort1 [dict get $parameters "AutoNegotiatePort1"]
set autoNegotiatePort2 [dict get $parameters "AutoNegotiatePort2"]

# 1-step or 2-step DUT
set twoStep [dict get $parameters "TwoStep"]

set graphing [dict get $parameters "Graphing"]

# ##############################################################################
# Configure instrument connection
# ------------------------------------------------------------------------------
# If guiIp (guiHostname) is not set to localhost, then it is assumed that the 
# P-X application is running on a remote host
#
set instrIpAddress [dict get $parameters "InstrIp"]
set guiHostname [dict get $parameters "GuiIp"]
set instrPort "9990"
set guiPort [dict get $parameters "GuiPort"]

if {$guiHostname != "localhost"} {
#	package require rest
	set remoteHost TRUE
}
#set remoteCaptureFolder [dict get $parameters "RemoteCaptureFolder"]
#set remoteProfileFolder [dict get $parameters "RemoteProfileFolder"]
# ------------------------------------------------------------------------------


#######################################################################
# Parse the Master/SlaveMcastAddress parameters
#---------------------------------------------------------------
# Config Multicast Addresses
set masterMcastAddress [dict get $parameters "MasterMcastAddress"]
set slaveMcastAddress [ dict get $parameters "SlaveMcastAddress"]
    
if { $masterMcastAddress != "FORWARDABLE"  &&  $masterMcastAddress != "NONFORWARDABLE"} {
    log "ERROR: MasterMcastAddress illegal parameter value. Expected one of: FORWARDABLE, NONFORWARDABLE"
    exit
}
    
    
if { $slaveMcastAddress != "FORWARDABLE"  && $slaveMcastAddress != "NONFORWARDABLE"} {
    log "ERROR: SlaveMcastAddress illegal parameter value. Expected one of: FORWARDABLE, NONFORWARDABLE"
    exit
}


# ##############################################################################
# Based on the settings, check that the required packages are installed
# ------------------------------------------------------------------------------
set reqdPackages ""
# rest required if using remotely hosted Paragon-X
if {$guiHostname != "localhost"} {
	if { [catch {package require rest} ] } {
		set reqdPackages "$reqdPackages rest"
	}
}
# Tk, img and rbc required if Graphing is enabled
if {$graphing} {
	if { [catch {package require Tk} ] } {
		set reqdPackages "$reqdPackages Tk"
	}
	if { [catch {package require Img} ] } {
		set reqdPackages "$reqdPackages Img"
	}
	if { [catch {package require rbc} ] } {
		set reqdPackages "$reqdPackages rbc"
	}
}

if {$reqdPackages != ""} {
	puts "\nOne or more packages must be installed for the options you have selected."
	puts "The packages are: $reqdPackages"
	puts "If you are using ActiveState ActiveTcl, use 'teacup install <packageName>' to install these packages"
	puts "If you are using another Tcl distribution, please consult its documentation for installing packages"
	exit
}

# ##############################################################################
# Do the test. Steps are:
# 	- Create the required results folders and files
#	- Configure P-X
#	- Do the test
#	- Clean up
# ------------------------------------------------------------------------------
#
try {
		# Connect to Paragon-X and create instance
		ParagonX create par1
		par1 connect $instrIpAddress $guiHostname $instrPort $guiPort
	} on error { information detailedInformation } {
		puts $information
		#puts $detailedInformation
		#ObjectCleanUp
		exit
	}

try {
	# Do some basic initialisation of the script
	noiseTransferInitialise par1 $noiseTransferType $parameters $version $demoMode $remoteHost
	
	# Reset the Paragon-X to a factory default state
	if {!$demoMode} {
		log "Resetting Paragon-X..."
		par1 paragonset Rst TRUE
	
        par1 paragonset OperatingMode SERVICES
    
        # Configure measurements, ports and reference
        set meas [ Measurement new par1]
        par1 setMeasurementConfiguration $meas
        $meas measurementConfiguration $pdhWander $onePps $syncE
        
        #DJWAT AE-7
        #$meas portSetLineRate $lineRate
        #$meas portSetInterface $interface
        $meas portSetLineRate $lineRatePort1 0
        $meas portSetLineRate $lineRatePort2 1
        
        $meas portSetInterface $interfacePort1 0
        $meas portSetInterface $interfacePort2 1
    
    
        $meas referencesSetClockSource $referenceFrequency
            
        # Configure 1pps measurement port - consider moving it into the appropriate class
        par1 paragonset Physical AuxInputThreshold $1ppsLevel
        
        #ENT-42
        #  Set impedance on 1pps from defaults/customer choice
        par1 paragonset Physical AuxInputTermination $1ppsImpedance
    
        # Configure sync to external 1pps - consider moving it into the measurement class
        par1 paragonset MasterSlave Master #0 SyncToExternal1pps $syncToExternal1pps
        
        # setting the Ethernet Auto Negotiate - defaults to FALSE, user must command line override for TRUE
    
        # DJWAT AE-7
        #  Need to make autonegotiate port dependent when uncoupled is being used
        
        #if {$lineRate != "10GBE"} {
        #    par1 paragonset Physical EthAutonegotiate $autoNegotiate
        #}
    
    
        if {$lineRatePort1 != "10GBE"} {
            par1 paragonset Physical #0 EthAutonegotiate $autoNegotiatePort1
        }
        if {$lineRatePort2 != "10GBE"} {
            par1 paragonset Physical #1 EthAutonegotiate $autoNegotiatePort2
        }
        
        # Select the phase profile - consider moving it into the measurement class
        par1 paragonset MasterSlave StandardsProfile G.8275.1_PHASE_PROFILE
    
        # Configure MSE
        $meas masterSetEncapsulation ETHERNET
        $meas masterConfigureMulticast 
        $meas masterSetMessagesFrequencies 8 16
        par1 paragonset MasterSlave Master #0 TwoStep $twoStep 
    
        $meas slaveSetEncapsulation ETHERNET
        $meas slaveConfigureMulticast
        $meas slaveSetAllowedMasters 16
        $meas setCableDelay $cableDelay
        
        # Config Multicast Addresses
        # only need to set nonforwardable as it defaults to forwardable
        if {$masterMcastAddress == "NONFORWARDABLE" } {
                par1 paragonset MasterSlave Master #0 MulticastEthMACAddress "01 80 c2 00 00 0e"
        }
      
        
        if { $slaveMcastAddress == "NONFORWARDABLE" } {
                par1 paragonset MasterSlave Slave MulticastEthMACAddress "01 80 c2 00 00 0e"
        }
        
        # Before we start the tests, check some of the basics...
        # Check if links are up
        # If running a T-BC test need to check both links status, if testing a T-TSC need only check port1 link
        
        
        if { $noiseTransferType == "PTP-1PPS" || $noiseTransferType == "SyncE-1PPS" } {
            if {[$meas portLinkIsUp 0] == FALSE } {
                log "FATAL ERROR: Port1 link is down. Please check that your cabling is correct"
                exit
            }
            
        } else {
            if {[$meas portLinkIsUp 0] == FALSE || [$meas portLinkIsUp 1] == FALSE} {
                log "FATAL ERROR: One or both links are down. Please check that your cabling is correct"
                exit
            }
        }
        log "Links are up..."
    }
	
	# Configure the domain number - consider moving it into the measurement class
	# par1 paragonset MasterSlave Master #0 DomainNumber 24
	# par1 paragonset MasterSlave Slave DomainNumber 24

	# timeNoiseTransfer does the noise transfer measurement
	timeNoiseTransfer par1 $noiseTransferType

	par1 disconnect
	
	#Object cleanup
	#ObjectCleanUp
} on error { information detailedInformation } {
	puts $information
	#log $detailedInformation
	#ObjectCleanUp
}

