
oo::class create Result {
    variable paragonObject timeMeasurement measurementAnalysis
    constructor { paragonObject1 measurementAnalysis1 timeMeasurement1 } {
        set paragonObject $paragonObject1
        set timeMeasurement $timeMeasurement1
        set measurementAnalysis $measurementAnalysis1
        $paragonObject calculateRequiredSetTrue
    }
    
    destructor {      
    }
    
    method setup { timeMeasurement } {
        $paragonObject paragonset Cat SelectSlot $timeMeasurement
        #$paragonObject calculate
        $paragonObject calculateSpecified $timeMeasurement $measurementAnalysis
    }
    
    
    method getMean {} {
        my setup $timeMeasurement
        
        if { $measurementAnalysis == "ATE" } {
             error "Error: mean result ( getMean ) is not accessible for this measurement analysis "
        } else {
        return [$paragonObject paragonget Cat $measurementAnalysis Mean] 
        }
    }
    
    # cTe result is only avaliable for ATE
    method getCTe {} {
        my setup $timeMeasurement
        
        if { $measurementAnalysis != "ATE" } {
             error "Error: cTe result ( getCTe ) is not accessible for this measurement analysis, only for ATE "
        } else {
        return [$paragonObject paragonget Cat $measurementAnalysis cTe]
        }
    }
    
    method getMin {} {
        my setup $timeMeasurement
        
        return [$paragonObject paragonget Cat $measurementAnalysis Min]
    }
    
    method getMax {} {
        my setup $timeMeasurement
        
        return [$paragonObject paragonget Cat $measurementAnalysis Max]
    }
    
    method getMax_Min {} {
        my setup $timeMeasurement
        
        return [$paragonObject paragonget Cat $measurementAnalysis Range]
    }
    
    
    method getMaskResult { } {
        my setup $timeMeasurement
         
        # mask result is only avaliable for MTIE and TDEV Dynamic Time Error - thus the error is thrown when measurementAnalysis is none of these
        if { $measurementAnalysis != "DTEMTIE" && $measurementAnalysis != "DTETDEV" } {
            error " Error: Mask result ( getMaskResult ) is not accessible for this measurement analysis: $measurementAnalysis $timeMeasurement, only for DTEMTIE and DTETDEV"      
        } else {
            return [par1 paragonget Cat $measurementAnalysis MaskResult] 
        }
    }
    
    method getLimitResult {} {
        my setup $timeMeasurement
        
        # limit result is only avaliable for ATE, TE, 2Way DTE LF and 2Way DTE HF - thus the error is thrown when measurementAnalysis is none of these
        if { $measurementAnalysis != "TE" && $measurementAnalysis != "ATE" && !( ($measurementAnalysis == "DTE" || $measurementAnalysis == "DTEHF") && $timeMeasurement == "2Way" ) } {   
            error " Error: Limit result ( getLimitResult ) is not accessible for this measurement: $measurementAnalysis $timeMeasurement, only for TE, ATE, DTE 2Way or DTEHF 2Way "      
        } else {
            return [par1 paragonget Cat $measurementAnalysis MaskResult ]
        }
    }


}

# =================================================================================================


oo::class create ResultSet1 {
    superclass Result
    variable paragonObject timeMeasurement measurementAnalysis
    
    constructor { paragonObject1 measurementAnalysis1 timeMeasurement1 } {
        next $paragonObject1 $measurementAnalysis1 $timeMeasurement1
    }
    
    destructor {      
    }
    
    method getFwdMessages {} {
        my setup $timeMeasurement
        return [$paragonObject paragonget Cat $measurementAnalysis FwdMessages]
    }
    
    method getRevMessages {} {
        my setup $timeMeasurement
        return [$paragonObject paragonget Cat $measurementAnalysis RevMessages]
    }
    
    method getForwardRate {} {
        my setup $timeMeasurement
        return [$paragonObject paragonget Cat $measurementAnalysis FwdRate]
    }
    
    method getReverseRate {} {
        my setup $timeMeasurement
        return [$paragonObject paragonget Cat $measurementAnalysis RevRate]
    }
}

# =================================================================================================


oo::class create ResultSet2 {
    superclass Result
    variable paragonObject timeMeasurement measurementAnalysis
    
    constructor { paragonObject1 measurementAnalysis1 timeMeasurement1 } {
        next $paragonObject1 $measurementAnalysis1 $timeMeasurement1 
    }
    
    destructor {      
    }
    
    method getMessages {} {
        my setup $timeMeasurement
        return [$paragonObject paragonget Cat $measurementAnalysis Messages]
    }
    
    method getRate {} {
        my setup $timeMeasurement
        return [$paragonObject paragonget Cat $measurementAnalysis Rate]
    }
}

# =================================================================================================


